package exam.first;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;

public class Final46 {
	public static void main(String[] args) {
		List<Employee1> roster = new ArrayList<>();
		roster.add(new Employee1("mike", 500, "west"));
		roster.add(new Employee1("jack", 100, "west"));
		roster.add(new Employee1("wen", 300, "east"));
		roster.add(new Employee1("linda", 800, "east"));
		//Map<String, Optional<Employee1>> m = roster.stream().collect(Collectors.groupingBy(e -> e.getNeighborhood(),
				//Collectors.maxBy((x, y) -> x.getSalary() - y.getSalary()))); // line 1
		Map<String, Optional<Employee1>> m = roster.stream()
		//.collect(Collectors.maxBy(Employee1::getSalary),Collectors.groupingBy(Comparator.comparing(e->e.getNeightborhood())));
		//.collect(Collectors.groupingBy(Employee1::getNeiborhood,Collectors.maxBy(Comparator.comparing(Employee::getSalary))));
		.collect(Collectors.groupingBy(e->e.getNeighborhood(),Collectors.maxBy((y,x)->y.getSalary()-x.getSalary())));
		System.out.println(m);

	}
}

class Employee1 {
	String name;
	int salary;
	String neighborhood;

	public int getSalary() {
		return salary;
	}

	public void setSalary(int salary) {
		this.salary = salary;
	}

	public String getNeighborhood() {
		return neighborhood;
	}

	public void setNeighborhood(String neighborhood) {
		this.neighborhood = neighborhood;
	}

	Employee1(String name, int salary, String neighborhood) {
		this.name = name;
		this.salary = salary;
		this.neighborhood = neighborhood;
	}

	@Override
	public String toString() {
		return "Employee1 [name=" + name + ", salary=" + salary + ", neighborhood=" + neighborhood + "]";
	}
}
